//Ruuby JsBridge
(function (win) {
    var hasOwnProperty = Object.prototype.hasOwnProperty;
    var RPQRCodeJSBridge = win.RPQRCodeJSBridge || (win.RPQRCodeJSBridge = {});
    var JSBRIDGE_PROTOCOL = 'RPQRCodeJSBridge';
    var Inner = {
        callbacks: {},
        absoluteUnitToPixel : function (params, callback) {
            var obj = 'calculate';
            var method = 'cmToPixel';
            var paramsJsonText = '{"cm":" '+ params + '"}';
            var paramsObj = JSON.parse(paramsJsonText);;
            var port = Util.getPort();
            this.callbacks[port] = callback;
            var uri=Util.getUri(obj,method,paramsObj,port);
            window.prompt(uri, "");
        },
        absoluteUnitToPixel_2: function (obj, method, params, callback) {
            var port = Util.getPort();
            this.callbacks[port] = callback;
            var uri=Util.getUri(obj,method,params,port);
            window.prompt(uri, "");
        },
        onFinish: function (port, jsonObj){
            var callback = this.callbacks[port];
            callback && callback(jsonObj);
            delete this.callbacks[port];
        },
    };
    var Util = {
        getPort: function () {
            return Math.floor(Math.random() * (1 << 30));
        },
        getUri:function(obj, method, params, port){
            params = this.getParam(params);
            var uri = JSBRIDGE_PROTOCOL + '://' + obj + ':' + port + '/' + method + '?' + params;
            return uri;
        },
        getParam:function(obj){
            if (obj && typeof obj === 'object') {
                return JSON.stringify(obj);
            } else {
                return obj || '';
            }
        }
    };
    for (var key in Inner) {
        if (!hasOwnProperty.call(RPQRCodeJSBridge, key)) {
            RPQRCodeJSBridge[key] = Inner[key];
        }
    }
})(window);